// -*- C++ -*-
/*!
 * @file  MyServiceConsumer.h
 * @brief MyService Consumer Sample component
 * @date  $Date: 2008-02-29 04:55:08 $
 *
 * $Id: MyServiceConsumer.h 1562 2009-11-09 05:38:59Z kurihara $
 */

#ifndef MYSERVICECONSUMER_H
#define MYSERVICECONSUMER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <iostream>
#include <coil/Async.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">
#include "MyServiceStub.h"

// </rtc-template>

using namespace RTC;

class MyServiceConsumer
  : public RTC::DataFlowComponentBase
{
 public:
  MyServiceConsumer(RTC::Manager* manager);
  ~MyServiceConsumer();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
  virtual RTC::ReturnCode_t onInitialize();

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

 protected:
  // DataInPort declaration
  // <rtc-template block="inport_declare">
  
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  RTC::CorbaPort m_MyServicePort;
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  RTC::CorbaConsumer<SimpleService::MyService> m_myservice0;
  
  // </rtc-template>

 private:

};


extern "C"
{
  DLL_EXPORT void MyServiceConsumerInit(RTC::Manager* manager);
};

#endif // MYSERVICECONSUMER_H
