// -*- C++ -*-
/*!
 * @file  MyServiceProvider.h
 * @brief MyService Provider Sample component
 * @date  $Date: 2008-02-29 04:55:11 $
 *
 * $Id: MyServiceProvider.h 1402 2009-06-24 05:46:53Z hakuta $
 */

#ifndef MYSERVICEPROVIDER_H
#define MYSERVICEPROVIDER_H

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>

// Service implementation headers
// <rtc-template block="service_impl_h">
#include "MyServiceSVC_impl.h"

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

using namespace RTC;

class MyServiceProvider
  : public RTC::DataFlowComponentBase
{
 public:
  MyServiceProvider(RTC::Manager* manager);
  ~MyServiceProvider();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
  virtual RTC::ReturnCode_t onInitialize();

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

 protected:
  // DataInPort declaration
  // <rtc-template block="inport_declare">
  
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  RTC::CorbaPort m_MyServicePort;
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  MyServiceSVC_impl m_myservice0;
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:

};


extern "C"
{
  DLL_EXPORT void MyServiceProviderInit(RTC::Manager* manager);
};

#endif // MYSERVICEPROVIDER_H
